package com.ouling.weibo.util;

import java.io.InputStream;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.app.Activity;
import android.graphics.Bitmap;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MenuItem.OnMenuItemClickListener;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.ImageView.ScaleType;
import android.widget.LinearLayout;
import android.widget.Toast;
import android.widget.ZoomControls;
import com.ouling.weibo.R;
import com.ouling.weibo.pic.GIFView;
import com.ouling.weibo.util.AsyncImageView;

/*
 * ö㴥ImageViewͼķŴС ָͼƬƶ
 */
public class MyView extends Activity implements OnMenuItemClickListener {

	private Button btn_cancel, btn_save;
	private ZoomControls zc;
	private MyImageView imageView;
	// public static Bitmap bitmap;

	// ʼʱͼƬλ
	public static int init_left, init_right, init_top, init_bottom;
	private boolean init_flag;

	// ӦĻͼƬĴС
	public static float bitmap_width, bitmap_height;

	// ͼƬĻĴС
	private float scale_x, scale_y;

	// 㴥֮ĳ
	public static float beforeLenght;
	public static float afterLenght;

	// ƶǰֵ
	public static float afterX, afterY;
	public static float beforeX, beforeY;

	// ŵıǣ֪Ϊʲô㴥ֻӦmoveupԼһλ
	public static boolean point_first;

	public static int screenWidth;
	public static int screenHeight;

	public static Bitmap myBitmap;

	private String saveFileName;

	// رǣ(1)(2)ǵһδĻ(3)
	private int point_flag;

	private String url;

	private GIFView gifView;
	private LinearLayout myview_waitingView;

	private static final int GIF_DOWNLOAD_SUCCESS = 5;

	private Handler handler = new Handler() {

		@Override
		public void handleMessage(Message msg) {
			switch (msg.what) {
				case GIF_DOWNLOAD_SUCCESS:
					myview_waitingView.setVisibility(View.GONE);
					MyView.this.setContentView(gifView);
					Toast.makeText(MyView.this, "ͼƬ", Toast.LENGTH_LONG)
							.show();
					break;
				case AsyncImageView.DOWNLOAD_GIF:
					gifinit();
					break;

				case AsyncImageView.DOWNLOAD_COMPLETED:
					myview_waitingView.setVisibility(View.GONE);
					Toast.makeText(MyView.this, "ͼƬ", Toast.LENGTH_LONG)
							.show();
					init();
					break;

				default:
					Toast.makeText(MyView.this, "ȡͼƬʧ", Toast.LENGTH_LONG)
							.show();
					MyView.this.finish();
			}
		}
	};;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
				WindowManager.LayoutParams.FLAG_FULLSCREEN);

		setContentView(R.layout.myview);

		WindowManager manager = getWindowManager();
		screenWidth = manager.getDefaultDisplay().getWidth();
		screenHeight = manager.getDefaultDisplay().getHeight();

		Bundle bundle = getIntent().getExtras();
		if (bundle == null || !bundle.containsKey("url")) {
			Toast.makeText(this, "ȡͼƬʧ", Toast.LENGTH_LONG).show();
			finish();
		}

		url = bundle.getString("url");

		imageView = (MyImageView) findViewById(R.id.imageView);
		imageView.setHandler(handler);
		imageView.setUrl(url);
		btn_cancel = (Button) findViewById(R.id.btn_return);
		btn_save = (Button) findViewById(R.id.btn_save);
		zc = (ZoomControls) findViewById(R.id.zoomControls);
		myview_waitingView = (LinearLayout) findViewById(R.id.myview_waitingView);
		zc.setVisibility(View.GONE);
		btn_cancel.setVisibility(View.GONE);
		btn_save.setVisibility(View.GONE);
	}

	protected void gifinit() {
		try {
			HttpClient client = new DefaultHttpClient();
			HttpGet get = new HttpGet(url);
			HttpResponse response = client.execute(get);
			HttpEntity entity = response.getEntity();
			long length = entity.getContentLength();

			if (length <= 0)
				throw new Exception();

			InputStream is = entity.getContent();
			gifView = new GIFView(this, is);
			handler.sendEmptyMessage(GIF_DOWNLOAD_SUCCESS);
		} catch (Exception e) {
			e.printStackTrace();
			handler.sendEmptyMessage(10000);
		}

	}

	private void init() {
		zc.setVisibility(View.VISIBLE);
		btn_cancel.setVisibility(View.VISIBLE);
		btn_save.setVisibility(View.VISIBLE);

		btn_cancel.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				MyView.this.finish();
			}
		});
		btn_save.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				savaBitmap();
			}
		});

		zc.setOnZoomInClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				if (init_flag) {
					getSize();
				}
				imageView.setScale((imageView.getRight() - imageView.getLeft()) / 8);
//				enableZC();
			}
		});
		zc.setOnZoomOutClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				if (init_flag) {
					getSize();
				}
				imageView.setScale((imageView.getLeft() - imageView.getRight()) / 8);
//				enableZC();
			}
		});
		zc.setIsZoomInEnabled(true);
		zc.setIsZoomOutEnabled(true);
		
		// ͼƬImageView
		imageView.setScaleType(ScaleType.FIT_CENTER);
		point_first = true;
		point_flag = 3;

		scale_x = imageView.getBitmap().getWidth() / screenWidth;
		scale_y = imageView.getBitmap().getHeight() / screenHeight;
		float scale_ratio = Math.max(scale_x, scale_y);

		bitmap_width = imageView.getBitmap().getWidth() / scale_ratio;
		bitmap_height = imageView.getBitmap().getHeight() / scale_ratio;

		scale_x = bitmap_width / screenWidth;
		scale_y = bitmap_height / screenHeight;

		init_flag = true;
	}

	private void getSize() {
		init_left = imageView.getLeft();
		init_right = imageView.getRight();
		init_top = imageView.getTop();
		init_bottom = imageView.getBottom();
		init_flag = false;
	}

	@Override
	public boolean onTouchEvent(MotionEvent event) {

		if (init_flag) {
			getSize();
		}

		if (MotionEvent.ACTION_UP == event.getAction()) {
			point_first = true;
			point_flag = 3;
			return true;
		}
		if (point_flag == 3) {

			if (event.getPointerCount() == 2) {
				imageView.scaleWithFinger(event);
				point_flag = 2;
			} else if (event.getPointerCount() == 1) {
				imageView.moveWithFinger(event);
				point_flag = 1;
			}

		} else if (point_flag == 2) {
			if (MotionEvent.ACTION_POINTER_UP == event.getAction()) {
				point_first = true;
				return true;
			}
			if (event.getPointerCount() == 2) {
				imageView.scaleWithFinger(event);
			}

		} else {
			point_first = true;
			if (event.getPointerCount() == 2) {
				imageView.scaleWithFinger(event);
				point_flag = 2;
			} else {
				imageView.moveWithFinger(event);
			}
		}
//		enableZC();
		imageView.invalidate();
		return true;
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		menu.add(1, 1, 1, "Ƭ").setOnMenuItemClickListener(this);
		return true;
	}

	public boolean onMenuItemClick(MenuItem item) {
		switch (item.getItemId()) {
			case 1:
				savaBitmap();
				break;
			default:
				return false;
		}
		return true;
	}

	private void savaBitmap() {
		/*
		 * ps:ڿǵҪʮּܡõһַҪ ֱõڶ
		 */

		/**
		 * ԰imageViewرϵͳṩDrawingCacheֵ
		 * ͨimageView.layout(0, 0, screenWidth, screenHeight)ʵ
		 */
		imageView.layout(0, 0, (int) screenWidth, (int) screenHeight);
		if (false == imageView.isDrawingCacheEnabled()) {
			imageView.setDrawingCacheEnabled(true);
		}
		myBitmap = imageView.getDrawingCache();

		/**
		 * һֱ֣ӻȡimageViewڵviewȻֱӽͼ
		 */
		// View v = imageView.getRootView();
		// if (false == v.isDrawingCacheEnabled()) {
		// v.setDrawingCacheEnabled(true);
		// }
		// myBitmap = v.getDrawingCache();
		//

		if (myBitmap == null) {
			Toast.makeText(MyView.this, "ʧ", Toast.LENGTH_LONG).show();
		} else {
			saveFileName = InfoHelper.getWeiboPath() + InfoHelper.getFileName()
					+ ".jpg";
			if (ImageRel.saveMyBitmap(saveFileName, myBitmap))
				Toast.makeText(MyView.this, "ɹλ" + saveFileName,
						Toast.LENGTH_LONG).show();
			else
				Toast.makeText(MyView.this, "ʧ", Toast.LENGTH_LONG).show();
		}
	}

//	private void enableZC() {
//		int temp = (imageView.getRight() - imageView.getLeft()) / 8;
//		int left = imageView.getLeft() - temp;
//		int right = imageView.getRight() + temp;
//		int top = imageView.getTop() - temp;
//		int bottom = imageView.getBottom() + temp;
//		zc.setIsZoomInEnabled(true);
//		zc.setIsZoomOutEnabled(true);
//		// if (right - left > imageView.getBitmap().getWidth() * 5
//		// || bottom - top > imageView.getBitmap().getHeight() * 5)
//		// zc.setIsZoomInEnabled(false);
//
//		temp = 0;
//		left = imageView.getLeft() - temp;
//		right = imageView.getRight() + temp;
//		top = imageView.getTop() - temp;
//		bottom = imageView.getBottom() + temp;
////		if (right - left < MyView.bitmap_width / 5
////				|| bottom - top < MyView.bitmap_height / 5)
////			zc.setIsZoomOutEnabled(false);
//	}

}